## ats-lang-anairiats 0.2.6

=== Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Potential of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi.
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
##
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
##
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
## Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
## 02110-1301, USA.
##

######

##
## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Author: Likai Liu (liulk AT cs DOT bu DOT edu)
## Author: Yuri D'Elia (wavexx AT thregr DOT org)
##

.SUFFIXES:
all:: Makefile

######

# integration with autoconf.

SRC_CONFIG_FILES := config.mk.in config.h.in
BUILT_CONFIG_FILES := $(SRC_CONFIG_FILES:%.in=%)

Makefile: config.mk

config.status: configure
	./configure
	touch $@

$(BUILT_CONFIG_FILES): %: config.status $(filter-out %,$(SRC_CONFIG_FILES))
	./config.status
	touch $(BUILT_CONFIG_FILES)

config.h.in: configure.ac
	autoheader $<
	touch $@

configure: configure.ac $(SRC_CONFIG_FILES)
	aclocal
	automake --add-missing --foreign || true
	autoconf
	touch $(BUILT_CONFIG_FILES)

-include config.mk

######

DESTDIR :=

export ATSHOME
export ATSHOMERELOC
export ATSHOMEQ

######

#
# HX-2011-06-01:
# This part is by Georg Bauhaus (bauhaus AT arcor DOT de):
# It addresses the issue that the [-D] option is not available
# for $(INSTALL) on MacOSX.
#
.PHONY: install_dirs

install_dirs:: config.h
#
# make all subdirectories needed by install.
#
	cd $(abs_top_srcdir)
	[ -d $(DESTDIR)/$(bindir) ] || $(MKDIR_P) $(DESTDIR)/$(bindir)
	$(MKDIR_P) $(DESTDIR)$(ATSNEWHOME)/bin
	find ccomp contrib doc libats libc prelude -type d \
	  -exec $(MKDIR_P) $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	  -print

install_files:: install_dirs
#
# recursively install all files in the list except .svn control files.
#
	for d in ccomp/runtime contrib doc libats libc prelude; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -d $(DESTDIR)$(ATSNEWHOME)/"$$d" && \
	  find "$$d" -name .svn -prune -o -type f \
            -exec $(INSTALL) -m 644 \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print && \
	  find "$$d" -name .svn -prune -o -type l \
            -exec cp -d \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print; \
	done
#
# install specific files in the list as regular files.
#
	for f in \
	    COPYING INSTALL *.txt ccomp/lib/*.a ccomp/lib64/*.a config.h; \
	do \
	  [ -f "$$f" ] || continue; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 644 "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done
#
# install specific files in the list as executables.
#
	for f in bin/*; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done
#
# install multiple copies of wrapper script, for each binary.
#
	for f in bin/*; do \
	  b=`basename "$$f"`; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 ats_env.sh $(DESTDIR)$(bindir)/"$$b" && \
	  echo install ats_env.sh to $(bindir)/"$$b"; \
	done

install:: install_files

######

all:: \
  atsopt1 \
  bin/atscc \
  bin/atslib \
  libfiles libfiles_mt \
  bin/atspack \
  bin/atslex \
  ccomp/runtime/GCATS/gc.o \
  ccomp/runtime/GCATS/gc_mt.o \
  atsopt1_gc \
  contrib
	@echo "ATS/Anairiats has been built up successfully!"
	@echo "The value of ATSHOME for this build is \"$(ATSHOME)\"."
	@echo "The value of ATSHOMERELOC for this build is \"$(ATSHOMERELOC)\"."

###### w/o GC ######

atsopt1::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt
	cp bootstrap1/atsopt $(ATSHOMEQ)/bin/atsopt

###### with GC ######

atsopt1_gc::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt_gc
	cp bootstrap1/atsopt_gc $(ATSHOMEQ)/bin/atsopt

###### contrib libraries ######

contrib::
ifeq (1,1)
	$(MAKE) -C contrib/parcomb all
endif
ifeq ($(HAVE_LIBGLIB20),1)
	$(MAKE) -C contrib/glib all
endif
ifeq ($(HAVE_LIBGTK20),1)
	$(MAKE) -C contrib/cairo all
	$(MAKE) -C contrib/pango all
	$(MAKE) -C contrib/GTK all
endif
ifeq ($(HAVE_LIBSDL10),1)
	$(MAKE) -C contrib/SDL all
endif

###### some toplevel commands ######

bin/atscc bin/atslib:
	$(MAKE) -C utils/scripts atscc
	$(CPF) utils/scripts/atscc $(ATSHOMEQ)/bin
	$(MAKE) -C utils/scripts atslib
	$(CPF) utils/scripts/atslib $(ATSHOMEQ)/bin
	$(MAKE) -C utils/scripts clean

bin/atspack:
	$(MAKE) -C utils/scripts atspack
	cp utils/scripts/atspack $(ATSHOMEQ)/bin

###### library ######

ATS_PROOFCHECK=
#
# ATS_PROOFCHECK=-D_ATS_PROOFCHECK # it should be turned on from time to time
#
# [CC -E] for preprocessing
#

ATSLIB=$(ATSHOMEQ)/bin/atslib

.libfiles_local: .libfiles ; $(CC) -E -P -x c -o $@ $<
libfiles: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_smlbas

lib32files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_smlbas

lib64files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_smlbas

.libfiles_mt_local: .libfiles_mt ; $(CC) -E -P -x c -o $@ $<
libfiles_mt: .libfiles_mt_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_ATS_MULTITHREAD -O2 --libats_mt

###### a lexer for ATS ######

bin/atslex:
	cd utils/atslex; $(MAKE) atslex; cp atslex $(ATSHOMEQ)/bin
	cd utils/atslex; $(MAKE) clean

###### GC runtime ######

ccomp/runtime/GCATS/gc.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc.o; $(MAKE) clean

ccomp/runtime/GCATS/gc_mt.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc_mt.o; $(MAKE) clean

######

CPF=cp -f
RMF=rm -f

######

clean::
	$(RMF) bootstrap1/*.o
	$(MAKE) -C utils/scripts clean
	$(MAKE) -C utils/atslex clean
	$(MAKE) -C ccomp/runtime/GCATS clean

cleanall::
	$(RMF) bootstrap1/*.o
	$(RMF) $(BUILT_CONFIG_FILES)
	$(RMF) .libfiles_local
	$(RMF) .libfiles_mt_local
	$(RMF) bin/atsopt bin/atscc bin/atslib bin/atslex bin/atspack
	$(RMF) ccomp/lib/libats.a
	$(RMF) ccomp/lib/libats_mt.a
	$(RMF) ccomp/lib/libats_lex.a
	$(RMF) ccomp/lib/libats_smlbas.a
	$(RMF) ccomp/lib/output/*
	$(RMF) ccomp/lib64/libats.a
	$(RMF) ccomp/lib64/libats_mt.a
	$(RMF) ccomp/lib64/libats_lex.a
	$(RMF) ccomp/lib64/libats_smlbas.a
	$(RMF) ccomp/lib64/output/*
	$(RMF) contrib/glib/atsctrb_glib.o
	$(RMF) contrib/cairo/atsctrb_cairo.o
	$(RMF) contrib/pango/atsctrb_pango.o
	$(RMF) contrib/X11/atsctrb_X11.o
	$(RMF) contrib/GTK/atsctrb_GTK.o
	$(RMF) contrib/GL/atsctrb_GL.o
	$(RMF) contrib/GL/atsctrb_glut.o
	$(RMF) contrib/GL/atsctrb_gtkglext.o
	$(RMF) contrib/SDL/atsctrb_SDL.o

cleanall:: ; $(MAKE) -C utils/atslex cleanall
cleanall:: ; $(MAKE) -C utils/scripts cleanall
cleanall:: ; $(MAKE) -C ccomp/runtime/GCATS cleanall

distclean:: cleanall
distclean:: ; find . -name .svn -prune -o -name \*~ -exec rm \{} \;

######
#
# end of [Makefile_dist]
#
######

=== contrib/GLES2/Makefile ===
#
# Author: Artyom Shakhakov (artyom DOT shalkhakov AT gmail DOT com)
# Time: May, 2011
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

ATSCC=$(ATSUSRQ)/bin/atscc

######

all: atsctrb_GLES2.o clean

######

atsctrb_GLES2.o: gl2_sats.o
	ld -r -o $@ gl2_sats.o

######

gl2_sats.o: SATS/gl2.sats
	$(ATSCC) -o $@ -c SATS/gl2.sats

######

clean::
	rm -f gl2_sats.c gl2_sats.o

cleanall: clean
	rm -f atsctrb_GLES2.o

###### end of [Makefile] ######

=== contrib/GTK/Makefile ===
#
# API for GTK in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: May, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif # end of [ifeq]

######

ATSCC=$(ATSUSRQ)/bin/atscc -Wall
GTKCFLAGS = `pkg-config gtk+-2.0 --cflags`

######

all:: atsctrb_GTK.o
all:: clean

######

atsctrb_GTK.o: GTK_dats.o
	ld -r -o $@ GTK_dats.o

######

GTK_dats.o: DATS/gtk.dats
	$(ATSCC) $(GTKCFLAGS) -o $@ -c DATS/gtk.dats

######

RMF=rm -f

######

clean:: ; $(RMF) *_?ats.c *_?ats.o

cleanall:: clean
cleanall:: ; $(RMF) atsctrb_GTK.o

###### end of [Makefile] ######

=== contrib/cblas/TEST/Makefile ===
#
#
# Makefile for some BLAS testing code 
#
#

######

ATSUSRQ="$(ATSHOME)"
ATSLIBQ="$(ATSHOME)"
ifeq ("$(ATSHOME)","")
ATSUSRQ="/usr"
ATSLIBQ="/usr/lib/ats-anairiats-0.2.5"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt
LIBFLAGS=-L/usr/lib/atlas -L/usr/lib64/atlas
ATSCTRB=$(ATSLIBQ)/contrib/cblas/atsctrb_cblas.o

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: test_cblas
test_cblas: test_cblas.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_cblas.dats $(ATSCTRB) -lcblas -lm \
     && ./test_cblas
cleanall:: ; $(RMF) test_cblas

######

checkall:: test_gemm1
test_gemm1: test_gemm1.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_gemm1.dats $(ATSCTRB) -lcblas -lm \
     && ./test_gemm1
cleanall:: ; $(RMF) test_gemm1

checkall:: test_gemm2
test_gemm2: test_gemm2.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_gemm2.dats $(ATSCTRB) -lcblas -lm \
     && ./test_gemm2
cleanall:: ; $(RMF) test_gemm2

######

checkall:: test_symm
test_symm: test_symm.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_symm.dats $(ATSCTRB) -lcblas -lm \
     && ./test_symm
cleanall:: ; $(RMF) test_symm

######

checkall:: test_lu
test_lu: test_lu.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_lu.dats $(ATSCTRB) -lcblas -lm \
     && ./test_lu
cleanall:: ; $(RMF) test_lu

######

html:: ; $(ATSOPT) --posmark_html -d test_cblas.dats > test_cblas_dats.html
cleanall:: ; $(RMF) *_?ats.html

######

RMF=rm -f

######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== doc/EXAMPLE/AUP/Makefile ===
######
#
# Makefile file for some examples translated from the book:
# Advanced UNIX Programming (2nd edition) by Marc Rochkind
#
######

#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Start Time: Summer, 2009
# Second Time: Fall, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all: checkall

######

checkall: compall cleanall

######

compall:: testlock
testlock: AUP_2_4_3.dats; $(ATSCC) -o $@ $^

compall:: backward
backward: AUP_2_13.dats
	$(ATSCC) -o $@ $^ && ./$@ "AUP_2_13.dats"

compall:: backward2
backward2: AUP_2_14.dats
	$(ATSCC) -o $@ $^ && ./$@ "AUP_2_14.dats"

#######

compall:: pathnames
pathnames: AUP_3_4.dats; $(ATSCC) -o $@ $^ && ./$@

compall:: longls
longls: AUP_3_5.dats; $(ATSCC) -o $@ $^ && ./$@

compall:: getcwdx
getcwdx: AUP_3_6_4.dats; $(ATSCC) -o $@ $^ && ./getcwdx

#######

compall:: test421
test421: AUP_4_2_1.dats; $(ATSCC) -o $@ $^

compall:: test4221
test4221: AUP_4_2_2_1.dats; $(ATSCC) -o $@ $^

compall:: test4222
test4222: AUP_4_2_2_2.dats; $(ATSCC) -o $@ $^

compall:: test423
test423: AUP_4_2_3.dats; $(ATSCC) -o $@ $^

compall:: test435
test435: AUP_4_3_5.dats; $(ATSCC) -o $@ $^

compall:: test47
test47: AUP_4_7.dats; $(ATSCC) -o $@ $^ && ./test47

compall:: test48
test48: AUP_4_8.dats; $(ATSCC) -o $@ $^ -lcurses

#######

compall:: test52
test52: AUP_5_2.dats; $(ATSCC) -o $@ $^ && ./test52

#######

getargs.o: utils/getargs.c
	$(ATSCC) -Wall -c -o $@ $<

compall:: aupsh1
aupsh1: AUP_5_4.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

compall:: aupsh2
aupsh2: AUP_5_6.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

compall:: aupsh3
aupsh3: AUP_5_10.dats getargs.o
	$(ATSCC) -o $@ $< getargs.o

#######

compall:: test511
test511: AUP_5_11.dats
	$(ATSCC) -Wall -o $@ AUP_5_11.dats \
     && ./test511

#######

compall:: aupnice
aupnice: AUP_5_15.dats
	$(ATSCC) -Wall -o $@ $<

#######

compall:: test5173
test5173: AUP_5_17_3.dats
	$(ATSCC) -D_ATS_MULTITHREAD -Wall -o $@ AUP_5_17_3.dats -lpthread \
     && ./test5173

#######

errinfo.o: utils/errinfo.sats utils/errinfo.dats
	$(ATSCC) -IATS utils -I utils -Wall -c -o $@ utils/errinfo.dats

compall:: test631
test631: AUP_6_3_1.dats errinfo.o
	$(ATSCC) -I utils -Wall -o $@ $< errinfo.o && ./test631

compall:: test65
test65: AUP_6_5.dats errinfo.o
	$(ATSCC) -I utils -Wall -o $@ $< errinfo.o && ./test65

#######

compall:: test811
test811: AUP_8_1_1.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test811

compall:: test813
test813: AUP_8_1_3.dats; $(ATSCC) -I utils -Wall -o $@ $<

compall:: test814
test814: AUP_8_1_4.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test814

compall:: test823
test823: AUP_8_2_3.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test823

compall:: test826
test826: AUP_8_2_6.dats; $(ATSCC) -I utils -Wall -o $@ $< && ./test826

compall:: test83
test83: AUP_8_3.dats; $(ATSCC) -D_XOPEN_SOURCE -Wall -o $@ $< && ./test83

compall:: test8811
test8811: AUP_8_8_1_1.dats; $(ATSCC) -Wall -o $@ $< && ./test8811

compall:: test8812
test8812: AUP_8_8_1_2.dats; $(ATSCC) -Wall -o $@ $< && ./test8812

#######

compall:: test911
test911: AUP_9_1_1.dats; $(ATSCC) -Wall -o $@ $<

compall:: test917
test917: AUP_9_1_7.dats; $(ATSCC) -Wall -o $@ $<

compall:: test923
test923: AUP_9_2_3.dats; $(ATSCC) -Wall -o $@ $< && ./test923

compall:: test971
test971: AUP_9_7_1.dats; $(ATSCC) -Wall -o $@ $<

compall:: test972
test972: AUP_9_7_2.dats; $(ATSCC) -Wall -o $@ $< && ./test972

compall:: test974
test974: AUP_9_7_4.dats; $(ATSCC) -Wall -o $@ $<

compall:: test975 # it needs [clock_gettime] and [clock_getres]
test975: AUP_9_7_5.dats; $(ATSCC) -Wall -o $@ $< -lrt && ./test975

#######

xref:: ; $(ATSOPT) --posmark_xref=XREF -d \
  $(ATSHOME)/utils/xref/ats_prelude_xref.dats > /dev/null
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_4_3.dats > AUP_2_4_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_13.dats > AUP_2_13_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_2_14.dats > AUP_2_14_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_4.dats > AUP_3_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_5.dats > AUP_3_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_3_6_4.dats > AUP_3_6_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_1.dats > AUP_4_2_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_2_1.dats > AUP_4_2_2_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_2_2.dats > AUP_4_2_2_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_2_3.dats > AUP_4_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_3_5.dats > AUP_4_3_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_7.dats > AUP_4_7_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_4_8.dats > AUP_4_8_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_2.dats > AUP_5_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_4.dats > AUP_5_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_6.dats > AUP_5_6_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_10.dats > AUP_5_10_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_11.dats > AUP_5_11_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_15.dats > AUP_5_15_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_5_17_3.dats > AUP_5_17_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_6_3_1.dats > AUP_6_3_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_6_5.dats > AUP_6_5_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_1.dats > AUP_8_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_3.dats > AUP_8_1_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_1_4.dats > AUP_8_1_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_2_3.dats > AUP_8_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_2_6.dats > AUP_8_2_6_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_3.dats > AUP_8_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_8_8_1_1.dats > AUP_8_8_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_1_1.dats > AUP_9_1_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_1_7.dats > AUP_9_1_7_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_2_3.dats > AUP_9_2_3_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_1.dats > AUP_9_7_1_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_2.dats > AUP_9_7_2_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_4.dats > AUP_9_7_4_dats.html
xref:: ; $(ATSOPT) --posmark_xref=XREF -d AUP_9_7_5.dats > AUP_9_7_5_dats.html

######

RMF = rm -f

#######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o
	$(RMF) MySocket
	$(RMF) errinfo.o
	$(RMF) getargs.o

cleanall:: clean
	$(RMF) ./*_?ats.html
	$(RMF) ./XREF/*.html
cleanall::
	$(RMF) testlock
	$(RMF) backward
	$(RMF) backward2
	$(RMF) pathnames
	$(RMF) longls
	$(RMF) getcwdx
cleanall::
	$(RMF) test421
	$(RMF) test4221
	$(RMF) test4222
	$(RMF) test423
	$(RMF) test435
	$(RMF) test47
	$(RMF) test48
cleanall::
	$(RMF) test52
	$(RMF) aupsh1
	$(RMF) aupsh2
	$(RMF) aupsh3
	$(RMF) test511
	$(RMF) aupnice
	$(RMF) test5173
cleanall::
	$(RMF) test631
	$(RMF) test65
cleanall::
	$(RMF) test811
	$(RMF) test813
	$(RMF) test814
	$(RMF) test823
	$(RMF) test826
	$(RMF) test83
	$(RMF) test8811
	$(RMF) test8812
cleanall::
	$(RMF) test911
	$(RMF) test917
	$(RMF) test923
	$(RMF) test971
	$(RMF) test972
	$(RMF) test974
	$(RMF) test975

###### end of [Makefile] ######

=== doc/EXAMPLE/KernighanRitchie/Makefile ===
#
#
# Makefile for some K&R examples
#
#

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall:: ; make -C Chapter01 checkall
checkall:: ; make -C Chapter02 checkall
checkall:: ; make -C Chapter03 checkall
checkall:: ; make -C Chapter04 checkall
checkall:: ; make -C Chapter05 checkall
checkall:: ; make -C Chapter06 checkall
checkall:: ; make -C Chapter07 checkall
checkall:: ; make -C Chapter08 checkall

######

cleanall:: ; make -C  Chapter01 cleanall
cleanall:: ; make -C  Chapter02 cleanall
cleanall:: ; make -C  Chapter03 cleanall
cleanall:: ; make -C  Chapter04 cleanall
cleanall:: ; make -C  Chapter05 cleanall
cleanall:: ; make -C  Chapter06 cleanall
cleanall:: ; make -C  Chapter07 cleanall
cleanall:: ; make -C  Chapter08 cleanall

######

html:: ; make -C Chapter01 html
html:: ; make -C Chapter02 html
html:: ; make -C Chapter03 html
html:: ; make -C Chapter04 html
html:: ; make -C Chapter05 html
html:: ; make -C Chapter06 html
html:: ; make -C Chapter07 html
html:: ; make -C Chapter08 html  

######

upload:: upload01
upload01:: ; scp Chapter01/*.dats Chapter01/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter01

upload:: upload02
upload02:: ; scp Chapter02/*.dats Chapter02/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter02

upload:: upload03
upload03:: ; scp Chapter03/*.dats Chapter03/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter03

upload:: upload04
upload04:: ; scp Chapter04/*.dats Chapter04/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter04

upload:: upload05
upload05:: ; scp Chapter05/*.dats Chapter05/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter05

upload:: upload06
upload06:: ; scp Chapter06/*.dats Chapter06/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter06

upload:: upload07
upload07:: ; scp Chapter07/*.dats Chapter07/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter07

upload:: upload08
upload08:: ; scp Chapter08/*.dats Chapter08/*_dats.html \
  ats-hwxi,ats-lang@web.sourceforge.net:htdocs/EXAMPLE/KernighanRitchie/Chapter08

###### end of [Makefile] ######

=== doc/EXAMPLE/TEST/Makefile ===
#
#
# (kind of) unit testing for ATS library code
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: prelude_array
prelude_array: prelude_array.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array
cleanall:: ; $(RMF) prelude_array

checkall:: prelude_array0
prelude_array0: prelude_array0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array0
cleanall:: ; $(RMF) prelude_array0

checkall:: prelude_bool
prelude_bool: prelude_bool.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_bool
cleanall:: ; $(RMF) prelude_bool

checkall:: prelude_char
prelude_char: prelude_char.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_char
cleanall:: ; $(RMF) prelude_char

checkall:: prelude_float
prelude_float: prelude_float.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_float
cleanall:: ; $(RMF) prelude_float

checkall:: prelude_lazy_vt
prelude_lazy_vt: prelude_lazy_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_lazy_vt
cleanall:: ; $(RMF) prelude_lazy_vt

checkall:: prelude_list
prelude_list: prelude_list.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list
cleanall:: ; $(RMF) prelude_list

checkall:: prelude_list_vt
prelude_list_vt: prelude_list_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list_vt
cleanall:: ; $(RMF) prelude_list_vt

checkall:: prelude_matrix
prelude_matrix: prelude_matrix.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix
cleanall:: ; $(RMF) prelude_matrix

checkall:: prelude_matrix0
prelude_matrix0: prelude_matrix0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix0
cleanall:: ; $(RMF) prelude_matrix0

checkall:: prelude_string
prelude_string: prelude_string.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_string
cleanall:: ; $(RMF) prelude_string

######

checkall:: libc_math
libc_math: libc_math.dats
	$(ATSCC) -O2 -o $@ $< -lm && ./libc_math
cleanall:: ; $(RMF) libc_math

checkall:: libc_complex
libc_complex: libc_complex.dats
	$(ATSCC) -O2 -o $@ $< -lm && ./libc_complex
cleanall:: ; $(RMF) libc_complex

######

checkall:: libc_dirent
libc_dirent: libc_dirent.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_dirent "."
cleanall:: ; $(RMF) libc_dirent

checkall:: libc_dlfcn
libc_dlfcn: libc_dlfcn.dats
	$(ATSCC) -rdynamic -O2 -o $@ $< -ldl && ./libc_dlfcn "."
cleanall:: ; $(RMF) libc_dlfcn

######

checkall:: libc_gmp
libc_gmp: libc_gmp.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< -lats -lgmp && ./libc_gmp
cleanall:: ; $(RMF) libc_gmp

######

checkall:: libc_printf
libc_printf: libc_printf.dats
	$(ATSCC) -o $@ $< && ./libc_printf
cleanall:: ; $(RMF) libc_printf

######

checkall:: libc_pwd
libc_pwd: libc_pwd.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_pwd
cleanall:: ; $(RMF) libc_pwd

######

checkall:: libc_random
libc_random: libc_random.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_random
cleanall:: ; $(RMF) libc_random

######

checkall:: libc_sched
libc_sched: libc_sched.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< && ./libc_sched
cleanall:: ; $(RMF) libc_sched

######

checkall:: libc_stdio
libc_stdio: libc_stdio.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdio
cleanall:: ; $(RMF) libc_stdio

checkall:: libc_stdlib
libc_stdlib: libc_stdlib.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdlib
cleanall:: ; $(RMF) libc_stdlib

######

checkall:: libc_time
libc_time: libc_time.dats
	$(ATSCC) -D_XOPEN_SOURCE -O2 -o $@ $< && ./libc_time
cleanall:: ; $(RMF) libc_time

######

checkall:: libc_unistd
libc_unistd: libc_unistd.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_unistd
cleanall:: ; $(RMF) libc_unistd

######

checkall:: libc_sys_utsname
libc_sys_utsname: libc_sys_utsname.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_sys_utsname
cleanall:: ; $(RMF) libc_sys_utsname

######

checkall:: libc_gdbm_gdbm
libc_gdbm_gdbm: libc_gdbm_gdbm.dats ; $(ATSCC) -O2 -o $@ $< -lgdbm && ./libc_gdbm_gdbm
cleanall:: ; $(RMF) libc_gdbm_gdbm gdbmtest.gdbm

# checkall:: libc_gdbm_ndbm
libc_gdbm_ndbm: libc_gdbm_ndbm.dats ; $(ATSCC) -O2 -o $@ $< -lgdbm -lgdbm_compat && ./libc_gdbm_ndbm
cleanall:: ; $(RMF) libc_gdbm_ndbm ndbmtest.dir ndbmtest.pag

######

checkall:: libats_funarray_braun
libats_funarray_braun: libats_funarray_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< \
     && ./libats_funarray_braun 0 1 2 3 4 5 6 7 8 9
cleanall:: ; $(RMF) libats_funarray_braun

######

checkall:: libats_fundeque_fingertree
libats_fundeque_fingertree: libats_fundeque_fingertree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_fundeque_fingertree 10
cleanall:: ; $(RMF) libats_fundeque_fingertree

######

checkall:: libats_funheap_braun
libats_funheap_braun: libats_funheap_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funheap_braun

######

checkall:: libats_funmap_avltree
libats_funmap_avltree: libats_funmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funmap_avltree

checkall:: libats_funmap_rbtree
libats_funmap_rbtree: libats_funmap_rbtree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funmap_rbtree

######

checkall:: libats_funralist_nested
libats_funralist_nested: libats_funralist_nested.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funralist_nested

######

checkall:: libats_funset_avltree
libats_funset_avltree: libats_funset_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funset_avltree

######

checkall:: libats_funset_listord
libats_funset_listord: libats_funset_listord.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 1000
cleanall:: ; $(RMF) libats_funset_listord

######

checkall:: libats_genarrays
libats_genarrays: libats_genarrays.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_genarrays
cleanall:: ; $(RMF) libats_genarrays

######

checkall:: libats_hashtable_chain
libats_hashtable_chain: libats_hashtable_chain.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_chain 100000
cleanall:: ; $(RMF) libats_hashtable_chain

checkall:: libats_hashtable_linprb
libats_hashtable_linprb: libats_hashtable_linprb.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_linprb 100000
cleanall:: ; $(RMF) libats_hashtable_linprb

######

checkall:: libats_intinf
libats_intinf: libats_intinf.dats
	$(ATSCC) -O2 -o $@ $< -lats -lgmp && ./libats_intinf 10
cleanall:: ; $(RMF) libats_intinf

checkall:: libats_iterint
libats_iterint: libats_iterint.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_iterint
cleanall:: ; $(RMF) libats_iterint

######

checkall:: libats_linbitvec
libats_linbitvec: libats_linbitvec.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_linbitvec
cleanall:: ; $(RMF) libats_linbitvec

######

checkall:: libats_linmap_avltree
libats_linmap_avltree: libats_linmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linmap_avltree 100000
cleanall:: ; $(RMF) libats_linmap_avltree

checkall:: libats_linmap_rbtree
libats_linmap_rbtree: libats_linmap_rbtree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linmap_rbtree 100000
cleanall:: ; $(RMF) libats_linmap_rbtree

######

checkall:: libats_linqueue_arr
libats_linqueue_arr: libats_linqueue_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_arr 1000000
cleanall:: ; $(RMF) libats_linqueue_arr

######

checkall:: libats_linqueue_lst
libats_linqueue_lst: libats_linqueue_lst.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_lst 1000000
cleanall:: ; $(RMF) libats_linqueue_lst

######

checkall:: libats_linordset_randbst
libats_linordset_randbst: libats_linordset_randbst.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 1000000
cleanall:: ; $(RMF) libats_linordset_randbst

######

checkall:: libats_linstack_arr
libats_linstack_arr: libats_linstack_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linstack_arr 1000000
cleanall:: ; $(RMF) libats_linstack_arr

######

checkall:: libats_parworkshop
libats_parworkshop: libats_parworkshop.dats
	$(ATSCC) -D_ATS_MULTITHREAD -O2 -o $@ $< -lpthread -lats_mt && ./libats_parworkshop
cleanall:: ; $(RMF) libats_parworkshop

######

checkall:: libats_rarray
libats_rarray: libats_rarray.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_rarray
cleanall:: ; $(RMF) libats_rarray

######

checkall:: libats_regexp
libats_regexp: libats_regexp.dats
	$(ATSCC) -O2 -o $@ $< -lats -lpcre && ./libats_regexp
cleanall:: ; $(RMF) libats_regexp

######

checkall:: libats_vector
libats_vector: libats_vector.dats
	$(ATSCC) -O2 -o libats_vector libats_vector.dats && ./libats_vector
cleanall:: ; $(RMF) libats_vector

######

checkall:: libats_ngc_slist
libats_ngc_slist: libats_ngc_slist.dats
	$(ATSCC) -O2 -o $@ $< && ./$@
cleanall:: ; $(RMF) libats_ngc_slist

checkall:: libats_ngc_dlist
libats_ngc_dlist: libats_ngc_dlist.dats
	$(ATSCC) -O2 -o $@ $< && ./$@
cleanall:: ; $(RMF) libats_ngc_dlist

######

checkall:: libats_smlbas_array
libats_smlbas_array: libats_smlbas_array.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array

checkall:: libats_smlbas_array2
libats_smlbas_array2: libats_smlbas_array2.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array2

checkall:: libats_smlbas_char
libats_smlbas_char: libats_smlbas_char.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_char

checkall:: libats_smlbas_list
libats_smlbas_list: libats_smlbas_list.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_list

checkall:: libats_smlbas_string
libats_smlbas_string: libats_smlbas_string.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_string

checkall:: libats_smlbas_time
libats_smlbas_time: libats_smlbas_time.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas -lm && ./$@
cleanall:: ; $(RMF) libats_smlbas_time

######

RMF=rm -f

######

clean:
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== debian/changelog ===
ats-lang-anairiats (0.2.6-1ubuntu1) quantal; urgency=low

  * Don't include glib headers directly.

 -- Ilya Barygin <randomaction@ubuntu.com>  Sun, 24 Jun 2012 12:43:01 +0400

ats-lang-anairiats (0.2.6-1) unstable; urgency=low

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Wed, 25 Jan 2012 13:24:57 -0500

=== debian/control ===
Source: ats-lang-anairiats
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
Standards-Version: 3.9.2
Homepage: http://www.ats-lang.org

Package: ats-lang-anairiats
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
Suggests: ats-lang-anairiats-examples, ats-lang-anairiats-doc
Description: ATS language compiler named Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler atsopt, the frontend atscc, and 
 the lexer atslex.

Package: ats-lang-anairiats-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Description: Examples for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some examples of the language.

Package: ats-lang-anairiats-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Section: doc
Description: Documentation for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some documentation for the language.

## ats-lang-anairiats 0.2.9

=== Makefile ===
--- 
+++ 
@@ -147,12 +147,15 @@
   atsopt1 \
   bin/atscc \
   bin/atslib \
-  libfiles libfiles_mt \
+  libfiles \
+  libfiles_mt \
   bin/atspack \
-  bin/atslex \
+  libatsdoca \
   ccomp/runtime/GCATS/gc.o \
   ccomp/runtime/GCATS/gc_mt.o \
   atsopt1_gc \
+  bin/atslex \
+  bin/atsdoc \
   contrib
 	@echo "ATS/Anairiats has been built up successfully!"
 	@echo "The value of ATSHOME for this build is \"$(ATSHOME)\"."
@@ -214,17 +217,17 @@
 
 .libfiles_local: .libfiles ; $(CC) -E -P -x c -o $@ $<
 libfiles: .libfiles_local
-	$(ATSLIB) $(ATS_PROOFCHECK) -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats
 	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_lex
 	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_smlbas
 
 lib32files: .libfiles_local
-	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats
 	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_lex
 	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_smlbas
 
 lib64files: .libfiles_local
-	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats
 	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_lex
 	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_smlbas
 
@@ -232,11 +235,19 @@
 libfiles_mt: .libfiles_mt_local
 	$(ATSLIB) $(ATS_PROOFCHECK) -D_ATS_MULTITHREAD -O2 --libats_mt
 
+libatsdoca: ; $(MAKE) -C libatsdoc
+
 ###### a lexer for ATS ######
 
 bin/atslex:
 	cd utils/atslex; $(MAKE) atslex; cp atslex $(ATSHOMEQ)/bin
 	cd utils/atslex; $(MAKE) clean
+
+###### GC runtime ######
+
+bin/atsdoc:
+	cd utils/atsdoc; $(MAKE) atsdoc; cp atsdoc $(ATSHOMEQ)/bin
+	cd utils/atsdoc; $(MAKE) clean
 
 ###### GC runtime ######
 
@@ -257,6 +268,7 @@
 	$(RMF) bootstrap1/*.o
 	$(MAKE) -C utils/scripts clean
 	$(MAKE) -C utils/atslex clean
+	$(MAKE) -C utils/atsdoc clean
 	$(MAKE) -C ccomp/runtime/GCATS clean
 
 cleanall::
@@ -264,16 +276,19 @@
 	$(RMF) $(BUILT_CONFIG_FILES)
 	$(RMF) .libfiles_local
 	$(RMF) .libfiles_mt_local
-	$(RMF) bin/atsopt bin/atscc bin/atslib bin/atslex bin/atspack
+	$(RMF) bin/atsopt bin/atscc bin/atslib
+	$(RMF) bin/atspack bin/atslex bin/atsdoc
 	$(RMF) ccomp/lib/libats.a
 	$(RMF) ccomp/lib/libats_mt.a
 	$(RMF) ccomp/lib/libats_lex.a
 	$(RMF) ccomp/lib/libats_smlbas.a
+	$(RMF) ccomp/lib/libatsdoc.a
 	$(RMF) ccomp/lib/output/*
 	$(RMF) ccomp/lib64/libats.a
 	$(RMF) ccomp/lib64/libats_mt.a
 	$(RMF) ccomp/lib64/libats_lex.a
 	$(RMF) ccomp/lib64/libats_smlbas.a
+	$(RMF) ccomp/lib64/libatsdoc.a
 	$(RMF) ccomp/lib64/output/*
 	$(RMF) contrib/glib/atsctrb_glib.o
 	$(RMF) contrib/cairo/atsctrb_cairo.o

=== contrib/jansson/Makefile ===
#
# API for cairo in ATS
#
# Start Time: August, 2012
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
#

######

ATSHOMEQ="$(ATSHOME)"

######

ATSCC=$(ATSHOMEQ)/bin/atscc
ATSCTRB="$(PATSHOME)"/contrib
JANSSONCLFLAGS=-ljansson

######

all::

######

all:: atsctrb_jansson.o
atsctrb_jansson.o: jansson_dats.o ; ld -r -o $@ $^

######

jansson_dats.o: DATS/jansson.dats
	$(ATSCC) -O2 -I$(ATSCTRB) -IATS$(ATSCTRB) -o $@ -c $< $(JANSSONCLFLAGS)

######

RMF=rm -f

######

all:: clean
clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.c *_?ats.o

######

cleanall:: clean
cleanall:: ; $(RMF) atsctrb_jansson.o

###### end of [Makefile] ######

=== contrib/jansson/TEST/Makefile ===
#
# A simple Makefile
#

######

ATSCC=$(ATSHOME)/bin/atscc

######

CCFLAGS=-O2

######

ATSCTRB=$(ATSHOME)/contrib

######

all::
all:: test01
all:: test02
all:: github_commits

######

clean::
cleanall::

######

test01: test01_dats.c
	$(ATSCC) $(CCFLAGS) -I$(ATSCTRB) -o $@ $< -ljansson
cleanall:: ; $(RMF) test01

test02: test02_dats.c
	$(ATSCC) $(CCFLAGS) -I$(ATSCTRB) -o $@ $< -ljansson
cleanall:: ; $(RMF) test02

######

github_commits: github_commits_dats.c
	$(ATSCC) $(CCFLAGS) -I$(ATSCTRB) -o $@ $< -ljansson -lcurl
cleanall:: ; $(RMF) github_commits

######

%_dats.c: %.dats ; $(ATSCC) -cc -IATS$(ATSCTRB) $<

######

RMF=rm -f

######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o *_?ats.c

######

cleanall:: clean

###### end of [Makefile] ######

=== debian/changelog ===
ats-lang-anairiats (0.2.9-1) unstable; urgency=low

  * New upstream release
  * Updated standards-version
  * Threaded "hardening" compilation options through build process

 -- Matthew Danish <mrd@debian.org>  Mon, 14 Jan 2013 14:40:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: ats-lang-anairiats
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthew Danish <mrd@debian.org>
-Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
-Standards-Version: 3.9.2
+Maintainer: Matthew Danish <mrd@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
+Standards-Version: 3.9.4.0
 Homepage: http://www.ats-lang.org
 
 Package: ats-lang-anairiats

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh  $@

override_dh_auto_configure:
	dh_auto_configure -- $(shell dpkg-buildflags --export=configure)

override_dh_clean:
	dh_clean
	make cleanall
	rm -f stamp-h1 config.log config.status .ATSHOME .ATSHOMERELOC
	rm -f ats_env.sh test.sh config.mk
	rm -f ccomp/lib/output/* ccomp/lib64/output/*
	rm -f ccomp/lib/*.a ccomp/lib64/*.a
	rm -f contrib/*/*.o
	rm -f contrib/clapack/TEST/test contrib/glib/HATS/glibconfig.hats
	rm -f bootstrap1/atsopt bootstrap1/atsopt_gc utils/scripts/atscc utils/scripts/atslib utils/scripts/atspack utils/atslex/atslex utils/atsdoc/atsdoc
